<template>
  <div class="column is-half">
    <h2 class="subtitle">Profile</h2>
    <p>Now lets create your profile. Other people on the site will see this, so go mad.</p>
    <hr />
    <form class="form">
      <b-field
        label="Username"
        :type="usernameAvailable"
        :message="usernameAvailableMessage">
        <b-input
          icon="user"
          v-model="user.username"
          maxlength="30"
          @blur="checkUsername">
        </b-input>
      </b-field>
      <div class="columns">
        <div class="column is-one-third">
          <label class="label">Profile Photo</label>
          <div class="box">
            <figure class="image is-square" @click="uploadProfileImage">
              <img :src="profileImageURL">
            </figure>
          </div>
        </div>
        <div class="column is-two-thirds">
          <b-field label="Bio">
            <b-input
              maxlength="500"
              type="textarea"
              placeholder="I'm Dave, and i love basketball. This led me to trying photography, although i'm not quite sure how."
              v-model="user.bio"></b-input>
          </b-field>
        </div>
      </div>
      <div class="columns is-multiline">
        <div class="column is-3">
          <b-field
            label="Camera Make">
            <b-input
              icon="camera-retro"
              v-model="user.camera.make">
            </b-input>
          </b-field>
        </div>
        <div class="column is-3">
          <b-field
            label="Camera Model">
            <b-input
              v-model="user.camera.model">
            </b-input>
          </b-field>
        </div>
        <div class="column is-6">
          <b-field label="Lens">
            <b-taginput
              placeholder="Type and then hit enter to add"
              v-model="user.camera.lens"
              type="is-dark">
            </b-taginput>
          </b-field>
        </div>
        <div class="column is-12">
          <b-field label="Accessories">
            <b-taginput
              placeholder="Type and then hit enter to add"
              v-model="user.camera.accessories"
              type="is-info">
            </b-taginput>
          </b-field>
        </div>
      </div>
      <div class="control is-pulled-right">
        <button
          class="button is-primary is-outlined"
          :class="{'is-loading': isLoading}"
          @click="saveProfileDetails">Next</button>
      </div>
    </form>
  </div>
</template>

<script>
import gql from 'graphql-tag'
import UPDATEUSERPROFILE_MUTATION from '@/graphql/User/UpdateUserProfile.gql'
import { uploadProfileImage } from '@/cloudinary'
import placeholder from '@/assets/placeholders/click-to-upload.png'
export default {
  data () {
    return {
      user: {
        username: '',
        camera: {
          lens: ['e.g. 100-300mm Sigma'],
          accessories: ['Tripod', 'Sunscreen', 'Chocolate Bar']
        }
      },
      usernameAvailable: null,
      usernameAvailableMessage: null,
      profileImageURL: placeholder,
      isLoading: false
    }
  },
  created () {
    this.$apollo.query({
      query: gql`query getUserOnboardStatus ($userId: ID!) {
        User (id: $userId) {
          id
          onboardStatus
          firstname
          lastname
        }
      }`,
      variables: {
        userId: localStorage.getItem('apollo-user')
      }
    }).then(({ data: { User } }) => {
      if (User.onboardStatus === null) this.$router.push({ name: 'onboard-account' })
      else if (User.onboardStatus === 2) this.$router.push({ name: 'feed' })
      this.user.username = User.firstname.toLowerCase() + User.lastname.toLowerCase()
      this.user.id = User.id
    })
  },
  methods: {
    checkUsername () {
      this.$apollo.query({
        query: gql` query checkUsername ($username: String!) {
          allUsers (filter: { username: $username }) {
            username
          }
        }`,
        variables: {
          username: this.user.username
        }
      }).then(({data}) => {
        if (data.allUsers.length > 0) {
          this.usernameAvailable = 'is-danger'
          this.usernameAvailableMessage = `Shoot! Seems like someone already has that username :/`
        } else {
          this.usernameAvailable = 'is-success'
          this.usernameAvailableMessage = `Cool! Nobody else has this username. Let's cruise!`
        }
      })
    },
    uploadProfileImage () {
      uploadProfileImage(this.user.id).then(result => {
        this.profileImageURL = result[0].thumbnail_url
        this.user.profileImage = result[0].public_id
      }).catch(error => console.error(error))
    },
    saveProfileDetails () {
      this.isLoading = true
      this.user.onboardStatus = 2
      this.$apollo.mutate({
        mutation: UPDATEUSERPROFILE_MUTATION,
        variables: {
          ...this.user
        }
      }).then(({data}) => {
        this.$router.push({ name: 'feed' })
      })
    }
  }
}
</script>
